<template>
  <FloatingCreateButton
    :shown="isShown"
    @click="isShown = true"
  />

  <v-dialog
    v-model="isShown"
    persistent
  >
    <FloatingContainer>
      <FormHeader
        icon="mdi-plus"
        headline="Создание гостя"
        subtitle="Заполните данные"
      />

      <section class="pt-4">
        <FormRow label="Имя гостя">
          <v-text-field
            v-model="newGuest.name"
            :rules="[validateName]"
            :maxlength="MAX_GUEST_NAME_LENGTH"
            placeholder="Имя"
          />
        </FormRow>

        <Feedback
          :message="feedback"
          type="error"
          classes="mt-4"
        />

        <FormRow spacing="large">
          <v-btn
            block
            rounded
            size="large"
            class="text-white font-bold bg-gradient-to-r from-teal-400 to-cyan-500"
            :class="{ 'opacity-50': !isDataFilled }"
            :readonly="!isDataFilled"
            :loading="isLoading"
            @click="onCreateClick"
          >
            Создать
          </v-btn>
        </FormRow>

        <FormRow>
          <v-btn
            block
            rounded
            size="small"
            variant="plain"
            :ripple="false"
            class="font-bold"
            @click="isShown = false"
          >
            Отмена
          </v-btn>
        </FormRow>
      </section>
    </FloatingContainer>
  </v-dialog>
</template>

<script setup lang="ts">
import { computed, reactive, ref, watch } from 'vue';

import FormRow from '@/components/layout/FormRow.vue';
import FormHeader from '@/components/layout/FormHeader.vue';
import FloatingContainer from '@/components/layout/FloatingContainer.vue';
import FloatingCreateButton from '@/components/layout/FloatingCreateButton.vue';

import Feedback from '@/components/content/Feedback.vue';

import { createStringValidator } from '@/validators';
import { useGuestsStore } from '@/stores';
import { MIN_GUEST_NAME_LENGTH, MAX_GUEST_NAME_LENGTH } from '@/declarations';

const guestsStore = useGuestsStore();
const validateName = createStringValidator({
  required: true,
  length: { min: MIN_GUEST_NAME_LENGTH, max: MAX_GUEST_NAME_LENGTH },
});

const isLoading = ref(false);
const isShown = ref(false);
const feedback = ref('');

const newGuest = reactive({
  name: '',
});

const isDataFilled = computed(() => {
  return validateName(newGuest.name) === true;
});

const onCreateClick = async () => {
  isLoading.value = true;

  const { data: { error } } = await guestsStore.createGuest({
    name: newGuest.name.trim(),
  });

  isLoading.value = false;

  if (error) {
    feedback.value = error.message;
    return;
  }

  isShown.value = false;
};

watch(isShown, () => {
  newGuest.name = '';
  feedback.value = '';
});
</script>